package de.ozgcloud.apilib.common.command.grpc;

import static org.assertj.core.api.Assertions.*;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mapstruct.factory.Mappers;
import org.mockito.InjectMocks;

class CommandMapperTest {

	@InjectMocks
	private CommandMapper mapper = Mappers.getMapper(CommandMapper.class);

	@Nested
	class TestBuildCreateCommandRequest {

		@Test
		void shouldBuildRequest() {
			var request = mapper.buildCreateCommandRequest(OzgCloudCommandTestFactory.create());

			assertThat(request).usingRecursiveComparison().isEqualTo(GrpcCreateCommandRequestTestFactory.create());
		}
	}

	@Nested
	class TestMapFromGrpc {

		@Test
		void shouldMap() {
			var result = mapper.fromGrpc(GrpcCommandTestFactory.create());

			assertThat(result).usingRecursiveComparison().ignoringFields("relationVersion").isEqualTo(OzgCloudCommandTestFactory.create());
		}
	}

}
